Index: main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CoAccreditedRemoteCDMFRImportManager.java
===================================================================
--- main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CoAccreditedRemoteCDMFRImportManager.java	(revision 0)
+++ main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CoAccreditedRemoteCDMFRImportManager.java	(revision 0)
@@ -0,0 +1,771 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.odfsync.cdmfr;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import javax.jcr.RepositoryException;
+
+import org.apache.avalon.framework.configuration.Configuration;
+import org.apache.avalon.framework.configuration.ConfigurationException;
+import org.apache.avalon.framework.logger.Logger;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.commons.lang.ArrayUtils;
+import org.apache.commons.lang.StringUtils;
+import org.w3c.dom.Document;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+import org.xml.sax.InputSource;
+import org.xml.sax.SAXException;
+
+import org.ametys.cms.contenttype.ContentType;
+import org.ametys.cms.observation.Event;
+import org.ametys.cms.observation.ObservationConstants;
+import org.ametys.cms.repository.ContentTypeExpression;
+import org.ametys.cms.repository.ContentTypeHelper;
+import org.ametys.cms.repository.LanguageExpression;
+import org.ametys.odf.SynchronizableContent;
+import org.ametys.odf.SynchronizeExpression;
+import org.ametys.odf.enumeration.OdfEnumerationConstant;
+import org.ametys.odf.program.AbstractProgram;
+import org.ametys.odf.program.Program;
+import org.ametys.odf.program.ProgramFactory;
+import org.ametys.odf.program.SubProgram;
+import org.ametys.plugins.odfsync.SynchronizationReport;
+import org.ametys.plugins.repository.AmetysObject;
+import org.ametys.plugins.repository.AmetysObjectIterable;
+import org.ametys.plugins.repository.AmetysRepositoryException;
+import org.ametys.plugins.repository.metadata.UnknownMetadataException;
+import org.ametys.plugins.repository.query.QueryHelper;
+import org.ametys.plugins.repository.query.expression.AndExpression;
+import org.ametys.plugins.repository.query.expression.Expression;
+import org.ametys.plugins.repository.query.expression.Expression.Operator;
+import org.ametys.runtime.config.Config;
+import org.ametys.runtime.util.I18nUtils;
+import org.ametys.runtime.util.I18nizableText;
+
+import com.opensymphony.workflow.WorkflowException;
+
+/**
+ * Class to import or synchronize ODF contents from CDMFR stream and handle co-accredited programs
+ *
+ */
+public class CoAccreditedRemoteCDMFRImportManager extends RemoteCDMFRImportManager
+{
+    /** Avalon Role */
+    @SuppressWarnings("hiding")
+    public static final String ROLE = CoAccreditedRemoteCDMFRImportManager.class.getName();
+    
+    /** The i18n translator */
+    protected I18nUtils _i18nUtils;
+    
+    /** The list of metadata to copy for mention program */
+    protected Set<String> _mentionMetadataPaths;
+    
+    /** The list of metadata to merge */
+    protected Set<String> _metadataPathsToMerge;
+    
+    /** The helper to merge shared metadata */
+    protected MergeMetadataForSharedProgramHelper _mergeMetadataHelper;
+    
+    
+    @Override
+    public void configure(Configuration configuration) throws ConfigurationException
+    {
+        super.configure(configuration);
+
+        _mentionMetadataPaths = new HashSet<String>();
+        Configuration mentionConf = configuration.getChild("mention");
+        if (mentionConf != null)
+        {
+            Configuration metadatas = mentionConf.getChild("metadata-to-copy");
+            if (metadatas != null)
+            {
+                for (Configuration metadataConf : metadatas.getChildren())
+                {
+                    String metadataPath = metadataConf.getAttribute("path");
+                    _mentionMetadataPaths.add(metadataPath);
+                }
+            }
+        }
+        
+        _metadataPathsToMerge = new HashSet<String>();
+        Configuration sharedWithConf = configuration.getChild("shared-with");
+        if (sharedWithConf != null)
+        {
+            Configuration metadatas = sharedWithConf.getChild("metadata-to-merge");
+            if (metadatas != null)
+            {
+                for (Configuration metadataConf : metadatas.getChildren())
+                {
+                    String metadataPath = metadataConf.getAttribute("path");
+                    _metadataPathsToMerge.add(metadataPath);
+                }
+            }
+        }
+    }
+    
+    @Override
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        super.service(manager);
+        _i18nUtils = (I18nUtils) manager.lookup(I18nUtils.ROLE);
+        _mergeMetadataHelper = (MergeMetadataForSharedProgramHelper) manager.lookup(MergeMetadataForSharedProgramHelper.ROLE);
+    }
+    
+    @Override
+    protected List<Program> importPrograms(InputStream stream, SynchronizationReport report, Logger logger) throws WorkflowException, AmetysRepositoryException
+    {
+        List<Program> importedPrograms = new ArrayList<Program>();
+        Map<Program, Boolean> updatedMentions = new HashMap<Program, Boolean>();
+        
+        try
+        {
+            // XML to Content
+            Document doc = _domParser.parseDocument(new InputSource(stream));
+            doc = transformDocument(doc, new HashMap<String, Object>(), report, logger);
+
+            String lang = _xPathProcessor.evaluateAsString(doc, "CDM/@language");
+            if (StringUtils.isEmpty(lang))
+            {
+                lang = Config.getInstance().getValueAsString("odf.programs.lang");
+            }
+            if (doc != null)
+            {
+                NodeList nodes = doc.getElementsByTagName("program");
+                
+                for (int i = 0; i < nodes.getLength(); i++)
+                {
+                    report.info("-------------------------------------------------------------------------------");
+                    Node contentNode = nodes.item(i);
+                    // String cdmId = contentNode.getAttributes().getNamedItem("CDMid").getTextContent();
+                    String contentName = _xPathProcessor.evaluateAsString(contentNode, "code");
+                    String contentLang = _xPathProcessor.evaluateAsString(contentNode, "@language");
+                    if (StringUtils.isEmpty(contentLang))
+                    {
+                        contentLang = lang;
+                    }
+                    
+                    contentLang = StringUtils.substring(contentLang, 0, 2).toLowerCase(); // on keep the language from the locale
+                    
+                    String educationKind = _xPathProcessor.evaluateAsString(contentNode, Program.EDUCATION_KIND);
+                    String mention = _xPathProcessor.evaluateAsString(contentNode, Program.MENTION);
+                    
+                    if (StringUtils.isNotBlank(mention) && "parcours".equals(educationKind))
+                    {
+                        Program coAccreditedProgram = importCoAccreditedProgram(contentNode, doc, contentLang, contentName, mention, updatedMentions, report, logger);
+                        if (coAccreditedProgram != null)
+                        {
+                            importedPrograms.add(coAccreditedProgram);
+                        }
+                    }
+                    else
+                    {
+                        SynchronizableContent content = getContent(ProgramFactory.PROGRAM_CONTENT_TYPE, contentLang, "code", contentName);
+                        if (content == null)
+                        {
+                            try
+                            {
+                                content = createProgram(contentNode, doc, contentName, contentLang, report, logger);
+                                importedPrograms.add((Program) content);
+                            }
+                            catch (WorkflowException e) 
+                            {
+                                String errorMsg = "Une erreur est survenue lors de la création du contenu " + contentName;
+                                report.error(errorMsg, e);
+                                logger.error(errorMsg, e);
+                            }
+                        }
+                        else
+                        {
+                            String infoMsg = "Synchronisation de la formation \"" + content.getTitle() + "\"";
+                            report.info(infoMsg);
+                            logger.info(infoMsg);
+                            if (synchronizeContent(doc, content, contentNode, report, logger, false, contentLang))
+                            {
+                                applyChanges(content, report, logger);
+                            }
+                            else
+                            {
+                                infoMsg = "Aucune modification détectée sur la formation \"" + content.getTitle() + "\" depuis la dernière synchronisation";
+                                report.info(infoMsg);
+                                logger.info(infoMsg);
+                            }
+                        }
+                    }
+                }
+            }
+
+            applyChangesToMentions(updatedMentions, doc, report, logger);
+        }
+        catch (IOException e)
+        {
+            throw new AmetysRepositoryException("Unable to read the input stream", e);
+        }
+        catch (SAXException e)
+        {
+            throw new AmetysRepositoryException("A problem occured while parsing the input stream.", e);
+        }
+        catch (ProcessingException e)
+        {
+            throw new AmetysRepositoryException("A problem occured while transforming the document.", e);
+        }
+        
+        return importedPrograms;
+    }
+    
+    /**
+     * Import co-accredited program
+     * @param contentNode the content node
+     * @param doc the document
+     * @param contentLang the content lang
+     * @param contentName the content name
+     * @param mentionLabel the mention label
+     * @param updatedMentions the mentions to update
+     * @param report the report logger
+     * @param logger the logger
+     * @return return the imported program
+     * @throws UnknownMetadataException if an unknown metadata error occurred
+     * @throws AmetysRepositoryException if an ametys repository error occurred
+     * @throws WorkflowException if a workflow error occurred
+     */
+    protected Program importCoAccreditedProgram(Node contentNode, Document doc, String contentLang, String contentName, String mentionLabel, Map<Program, Boolean> updatedMentions, SynchronizationReport report, Logger logger) throws UnknownMetadataException, AmetysRepositoryException, WorkflowException
+    {
+        Program importedProgram = null;
+        _mergeMetadataHelper.initialize(this);
+
+        String degree = _xPathProcessor.evaluateAsString(contentNode, Program.DEGREE);
+        String degreeCode = _enumerationHelper.getItemCode(OdfEnumerationConstant.DEGREE, degree);
+
+        String mentionKey = CDMSynchronizationHelper.getConstant(contentNode, _xPathProcessor.selectSingleNode(contentNode, Program.MENTION), _enumerationHelper, _xPathProcessor);
+        String mentionCode = _enumerationHelper.getItemCode(mentionKey, mentionLabel);
+        
+        if (mentionCode != null)
+        {
+            // Get or create the root program (mention) with the given mention's code and degree code
+            Program mentionProgram = getMentionProgram(contentLang, mentionCode, degreeCode);
+            if (mentionProgram == null)
+            {
+                try
+                {
+                    // The root program does not exist yet, create it
+                    String contentTitle = getMentionProgramTitle(mentionProgram, doc, contentNode, contentLang, report, logger);
+
+                    String infoMsg = "Création de la mention " + contentTitle;
+                    report.info(infoMsg);
+                    logger.info(infoMsg);
+
+                    String contentId = createContent(ProgramFactory.PROGRAM_CONTENT_TYPE, contentLang, contentName, contentTitle, _programWorkflowName, 1, null);
+                    mentionProgram = _resolver.resolveById(contentId);
+                    updatedMentions.put(mentionProgram, true);
+
+                    // Set the common and additional metadata from the imported co-accredited program. This is done only on root program (mention) creation
+                    setMentionCommonMetadata(mentionProgram, doc, contentNode, report, logger);
+                    setMentionAdditionalMetadata(mentionProgram, doc, contentNode, contentLang, report, logger);
+
+                    importedProgram = mentionProgram;
+                }
+                catch (WorkflowException e)
+                {
+                    String errorMsg = "Une erreur est survenue lors de la création de la mention " + contentName;
+                    report.error(errorMsg, e);
+                    logger.error(errorMsg, e);
+                }
+            }
+
+            // Is imported program already exist as a subprogram ?
+            SynchronizableContent content = _getSubProgram(contentNode, mentionProgram, report, logger);
+            
+            if (content == null)
+            {
+                // The imported program does not exist as subprogram, create it except if it is a shared subprogram
+                List<String> sharedWith = getSharedWithAsString(contentNode, report, logger);
+                if (sharedWith.isEmpty())
+                {
+                    // Search if there is a main subprogram shared with it.
+                    SubProgram mainSubProgram = getMainSubProgram(mentionProgram, contentNode, report, logger);
+                    if (mainSubProgram != null)
+                    {
+                        // The imported program is a shared subprogram, it will not be imported nor synchronized, only the main subprogram will be updated
+                        try
+                        {
+                            //Merge shared program metadata
+                            _mergeMetadataHelper.synchronizeSharedProgramNode(doc, mainSubProgram, contentNode, _metadataPathsToMerge, contentLang, report, logger);
+                            
+                            //The merge main program
+                            _mergeMetadataHelper.synchronizeMainProgram(mainSubProgram, _metadataPathsToMerge, report, logger);
+                        }
+                        catch (RepositoryException e)
+                        {
+                            String warnMsg = "Impossible de synchronizer les metadatas pour le programme principal \"" + mainSubProgram.getTitle() + "\"";
+                            report.info(warnMsg);
+                            logger.warn(warnMsg);
+                        }
+                    }
+                    else
+                    {
+                        // This a non-shared subprogram or the main shared subprogram was not imported yet, create it
+                        content = _createSubProgram(contentNode, mentionProgram, contentLang, report, logger);
+                        
+                        // Then synchronize it
+                        _synchronizeSubProgram(content, contentLang, mentionProgram, contentNode, doc, updatedMentions, true, report, logger);
+                    }
+                }
+                else
+                {
+                    // This is a main subprogram in a co-accredited program : create the subprogram and synchronize it
+                    content = _createSubProgram(contentNode, mentionProgram, contentLang, report, logger);
+                    
+                    // Then synchronize it
+                    _synchronizeSubProgram(content, contentLang, mentionProgram, contentNode, doc, updatedMentions, true, report, logger);
+                    
+                    // Browse existing shared subprograms to first merge them then delete them.
+                    for (String code : sharedWith)
+                    {
+                        SubProgram sharedSubProgram = getSharedSubProgram(mentionProgram, code, report, logger);
+                        if (sharedSubProgram != null)
+                        {
+                            String infoMsg = "Fusion avec le parcours partagé \"" + sharedSubProgram.getTitle() + "\"";
+                            report.info(infoMsg);
+                            logger.info(infoMsg);
+                            
+                            try
+                            {
+                                _mergeMetadataHelper.synchronizeSharedProgramNode((SubProgram) content, sharedSubProgram, _metadataPathsToMerge, report, logger);
+                            }
+                            catch (RepositoryException e)
+                            {
+                                String warnMsg = "Impossible de synchronizer les metadatas du programme partagé \"" + sharedSubProgram.getTitle() + "\" avec le programme principal \"" + content.getTitle() + "\"";
+                                report.warn(warnMsg);
+                                logger.warn(warnMsg);
+                            }
+                            
+                            infoMsg = "Suppression du parcours partagé secondaire \"" + sharedSubProgram.getTitle() + "\"";
+                            report.info(infoMsg);
+                            logger.info(infoMsg);
+                            
+                            // Then delete the secondary shared subprogram
+                            deleteSharedSubProgram(sharedSubProgram, report, logger);
+                        }
+                    }
+                    
+                    try
+                    {
+                        //Then merge main program
+                        _mergeMetadataHelper.synchronizeMainProgram((SubProgram) content, _metadataPathsToMerge, report, logger);
+                    }
+                    catch (RepositoryException e)
+                    {
+                        String warnMsg = "Impossible de synchronizer les metadatas du programme principal \"" + content.getTitle() + "\"";
+                        report.warn(warnMsg);
+                        logger.warn(warnMsg);
+                    }
+                }
+            }
+            else
+            {
+                // The imported program exists as subprogram
+                
+                List<String> sharedWith = getSharedWithAsString(contentNode, report, logger);
+                if (sharedWith.isEmpty())
+                {
+                    // Simply synchronize it 
+                    _synchronizeSubProgram(content, contentLang, mentionProgram, contentNode, doc, updatedMentions, false, report, logger);
+                }
+                else
+                {
+                    // This is a main subprogram
+                    // Synchronize subprogram from remote node
+                    _synchronizeSubProgram(content, contentLang, mentionProgram, contentNode, doc, updatedMentions, false, report, logger);
+                    
+                    try
+                    {
+                        //Then merge main program
+                        _mergeMetadataHelper.synchronizeMainProgram((SubProgram) content, _metadataPathsToMerge, report, logger);
+                    }
+                    catch (RepositoryException e)
+                    {
+                        String warnMsg = "Impossible de synchronizer les metadatas du programme principal \"" + content.getTitle() + "\"";
+                        report.warn(warnMsg);
+                        logger.warn(warnMsg);
+                    }
+                }
+            }
+        }
+        else
+        {
+            String error = "Il n'y a pas de code associée à la mention : " + mentionLabel + ". La formation n'a pas été importée.";
+            logger.error(error);
+            report.error(error);
+        }
+
+        return importedProgram;
+    }
+    
+    /**
+     * Synchronize a subprogram of a co-accredited mention
+     * @param content The subprogram to synchronize
+     * @param contentLang The content language
+     * @param mentionProgram The parent mention
+     * @param contentNode The node representing the subprogram
+     * @param doc The document
+     * @param updatedMentions The update mentions and their import mode
+     * @param importMode The import mode
+     * @param report The report
+     * @param logger The logger
+     * @throws UnknownMetadataException if an error occurred
+     * @throws AmetysRepositoryException if an ametys repository error occurred
+     * @throws WorkflowException if a workflow repository error occurred
+     */
+    protected void _synchronizeSubProgram (SynchronizableContent content, String contentLang, Program mentionProgram, Node contentNode, Document doc, Map<Program, Boolean> updatedMentions, boolean importMode, SynchronizationReport report, Logger logger) throws UnknownMetadataException, AmetysRepositoryException, WorkflowException
+    {
+        // Then synchronize subprogram from remote node
+        String infoMsg = "Synchronisation du parcours \"" + content.getTitle() + "\"";
+        report.info(infoMsg);
+        logger.info(infoMsg);
+        if (synchronizeContent(doc, content, contentNode, report, logger, importMode, contentLang))
+        {
+            if (!updatedMentions.containsKey(mentionProgram))
+            {
+                updatedMentions.put(mentionProgram, false);
+            }
+        }
+        else
+        {
+            infoMsg = "Aucune modification détectée sur le parcours \"" + content.getTitle() + "\" depuis la dernière synchronisation";
+            report.info(infoMsg);
+            logger.info(infoMsg);
+        }
+    }
+    
+    /**
+     * Delete a shared secondary subprogram.
+     * This subprogram was created by a precede import before the main subprogram was imported
+     * @param sharedProgram the shared program
+     * @param report the report logger
+     * @param logger the logger
+     */
+    protected void deleteSharedSubProgram(SynchronizableContent sharedProgram, SynchronizationReport report, Logger logger)
+    {
+        String programId = sharedProgram.getId();
+        String programName = sharedProgram.getName();
+        _observationManager.notify(new Event(_currentUserProvider.getUser(), ObservationConstants.CONTENT_DELETING, sharedProgram, new String[]{programName}));
+        
+        sharedProgram.remove();
+        sharedProgram.saveChanges();
+        
+        _observationManager.notify(new Event(_currentUserProvider.getUser(), ObservationConstants.CONTENT_DELETED, programId, new String[]{programName}));
+    }
+    
+    /**
+     * Get the main subprogram shared with the program representing by the content node
+     * @param mentionProgram the root mention program
+     * @param contentNode the content node
+     * @param report the report logger
+     * @param logger the logger
+     * @return the main subprogram if the program is a shared subprogram or <code>null</code> otherwise
+     */
+    protected SubProgram getMainSubProgram(Program mentionProgram, Node contentNode, SynchronizationReport report, Logger logger)
+    {
+        String programCode = _xPathProcessor.evaluateAsString(contentNode, Program.CODE);
+        
+        for (AmetysObject child : mentionProgram.getChildren())
+        {
+            if (child instanceof SubProgram)
+            {
+                SubProgram subProgram  = (SubProgram) child;
+                List<String> sharedProgram = Arrays.asList(subProgram.getSharedWith());
+                if (sharedProgram.contains(programCode))
+                {
+                    return subProgram;
+                }
+            }
+        }
+        return null;
+    }
+    
+    /**
+     * Get the shared subprogram with the given code
+     * @param mentionProgram The root mention program
+     * @param code The CDMfr code
+     * @param report the report logger
+     * @param logger the logger
+     * @return The shared subprogram if exist or <code>null</code> if not found
+     */
+    protected SubProgram getSharedSubProgram (Program mentionProgram, String code, SynchronizationReport report, Logger logger)
+    {
+        for (AmetysObject child : mentionProgram.getChildren())
+        {
+            if (child instanceof SubProgram)
+            {
+                SubProgram subProgram  = (SubProgram) child;
+                if (subProgram.getCode().equals(code))
+                {
+                    return subProgram;
+                }
+            }
+        }
+        return null;
+    }
+    
+    /**
+     * Get the list of "shared with" program from the remote document
+     * @param contentNode The content node
+     * @param report the report logger
+     * @param logger the logger
+     * @return The CDM code of shared program
+     */
+    protected List<String> getSharedWithAsString (Node contentNode, SynchronizationReport report, Logger logger)
+    {
+        List<String> codes = new ArrayList<String>();
+        
+        Node sharedWithNode = _xPathProcessor.selectSingleNode(contentNode, AbstractProgram.SHARED_WITH);
+        
+        if (sharedWithNode != null)
+        {
+            NodeList itemNodes = sharedWithNode.getChildNodes();
+            for (int j = 0; j < itemNodes.getLength(); j++)
+            {
+                String code = itemNodes.item(j).getTextContent().trim();
+                if (StringUtils.isNotBlank(code))
+                {
+                    codes.add(code);
+                }
+            }
+        }
+        
+        return codes;
+    }
+    
+    /**
+     * Apply changes to parent mention
+     * Default implementation updates the OrgUnits of the mention from its child subprograms.
+     * @param updatedMentions the mentions to update
+     * @param doc the document
+     * @param report the report logger
+     * @param logger the logger
+     */
+    protected void applyChangesToMentions(Map<Program, Boolean> updatedMentions, Document doc, SynchronizationReport report, Logger logger)
+    {
+        for (Program mention : updatedMentions.keySet())
+        {
+            boolean importMode = updatedMentions.get(mention);
+            applyChangesToMention(mention, importMode, doc, report, logger);
+        }
+    }
+    
+    /**
+     * Apply change for one mention program
+     * @param mention the mention program
+     * @param importMode true if the mention is imported
+     * @param doc the document
+     * @param report the report logger
+     * @param logger the logger
+     */
+    protected void applyChangesToMention (Program mention, boolean importMode, Document doc, SynchronizationReport report, Logger logger)
+    {
+        updateMentionOrgUnits(mention, doc, importMode);
+        applyChanges(mention, report, logger);
+    }
+    
+    /**
+     * Update the mention orgUnits
+     * @param mention the mention program
+     * @param doc the document
+     * @param importMode true if the mention is imported
+     * @return true if there are some changes
+     */
+    protected boolean updateMentionOrgUnits (Program mention, Document doc, boolean importMode)
+    {
+        boolean hasChanged = false;
+        Set<String> childOrgUnits = new HashSet<String>();
+        for (AmetysObject content : mention.getChildren())
+        {
+            if (content instanceof SubProgram)
+            {
+                childOrgUnits.addAll(((SubProgram) content).getOrgUnits());
+            }
+        }
+        
+        NodeList nodes = doc.getElementsByTagName("program");
+        if (nodes.getLength() > 0)
+        {
+            Node programNode = nodes.item(0);
+            Node orgUnitNode = _xPathProcessor.selectSingleNode(programNode, Program.ORG_UNITS_REFERENCES);
+            
+            if (CDMSynchronizationHelper.isSynchronizable(orgUnitNode))
+            {
+                if (importMode || !mention.getMetadataHolder().hasMetadata(Program.ORG_UNITS_REFERENCES + SynchronizableContent.REMOTE_SUFFIX))
+                {
+                    mention.synchronizeMetadata(Program.ORG_UNITS_REFERENCES, true);
+                    hasChanged = true;
+                }
+                
+                if (!ArrayUtils.isEquals(childOrgUnits.toArray(new String[childOrgUnits.size()]), mention.getRemoteStringArray(Program.ORG_UNITS_REFERENCES)))
+                {
+                    mention.setRemoteMetadata(Program.ORG_UNITS_REFERENCES, childOrgUnits.toArray(new String[childOrgUnits.size()]));
+                    hasChanged = true;
+                }
+            }
+            else
+            {
+                if (!ArrayUtils.isEquals(childOrgUnits.toArray(new String[childOrgUnits.size()]), mention.getStringArray(Program.ORG_UNITS_REFERENCES)))
+                {
+                    mention.getMetadataHolder().setMetadata(Program.ORG_UNITS_REFERENCES, childOrgUnits.toArray(new String[childOrgUnits.size()]));
+                    hasChanged = true;
+                }
+            }
+        }
+        
+        
+        return hasChanged;
+    }
+
+    /**
+     * Get the mention program
+     * @param lang the content lang
+     * @param mentionValue the mention value
+     * @param degreeValue the degree value
+     * @return the mention program (null if it doesn't exist)
+     */
+    protected Program getMentionProgram(String lang, String mentionValue, String degreeValue)
+    {
+        Expression cTypeExpr = new ContentTypeExpression(Operator.EQ, ProgramFactory.PROGRAM_CONTENT_TYPE);
+        Expression langExpr = null;
+        if (lang != null)
+        {
+            langExpr = new LanguageExpression(Operator.EQ, lang);
+        }
+        Expression mentionExpr = new SynchronizeExpression(Program.MENTION, mentionValue);
+        Expression degreeExpr = new SynchronizeExpression(Program.DEGREE, degreeValue);
+        Expression expr = new AndExpression(cTypeExpr, langExpr, mentionExpr, degreeExpr);
+        
+        String jcrQuery = QueryHelper.getXPathQuery(null, "ametys:content", expr, null);
+        AmetysObjectIterable<Program> contents = _resolver.query(jcrQuery);
+        
+        if (contents.hasNext())
+        {
+            return contents.next();
+        }
+        
+        return null;
+    }
+    
+    /**
+     * Get the mention title
+     * @param mentionProgram the mention program
+     * @param doc the document
+     * @param contentNode the content node
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return the mention title
+     */
+    protected String getMentionProgramTitle(SynchronizableContent mentionProgram, Document doc, Node contentNode, String lang, SynchronizationReport report, Logger logger)
+    {
+        String degree = _xPathProcessor.evaluateAsString(contentNode, Program.DEGREE); 
+        String degreeCode = _enumerationHelper.getItemCode(OdfEnumerationConstant.DEGREE, degree);
+        
+        String mentionKey = CDMSynchronizationHelper.getConstant(contentNode, _xPathProcessor.selectSingleNode(contentNode, Program.MENTION), _enumerationHelper, _xPathProcessor);
+        
+        String mentionLabel = _xPathProcessor.evaluateAsString(contentNode, Program.MENTION);
+        String mentionCode = _enumerationHelper.getItemCode(mentionKey, mentionLabel);
+        
+        I18nizableText mentionI18n = _enumerationHelper.getItemLabel(mentionKey, mentionCode);
+        I18nizableText degreeI18n = _enumerationHelper.getItemLabel(OdfEnumerationConstant.DEGREE, degreeCode);
+        
+        return _i18nUtils.translate(degreeI18n, lang) + " " + _i18nUtils.translate(mentionI18n, lang); 
+    }
+    
+    /**
+     * Set the common metadata for mention program
+     * @param mentionProgram the mention program
+     * @param doc the document
+     * @param contentNode the content node
+     * @param report the report logger
+     * @param logger the logger
+     */
+    protected void setMentionCommonMetadata(SynchronizableContent mentionProgram, Document doc, Node contentNode, SynchronizationReport report, Logger logger)
+    {
+        String degree = _xPathProcessor.evaluateAsString(contentNode, Program.DEGREE); 
+        String degreeCode = _enumerationHelper.getItemCode(OdfEnumerationConstant.DEGREE, degree);
+
+        String mentionKey = CDMSynchronizationHelper.getConstant(contentNode, _xPathProcessor.selectSingleNode(contentNode, Program.MENTION), _enumerationHelper, _xPathProcessor);
+        
+        String mentionLabel = _xPathProcessor.evaluateAsString(contentNode, Program.MENTION);
+        String mentionCode = _enumerationHelper.getItemCode(mentionKey, mentionLabel);
+
+        String domain = _xPathProcessor.evaluateAsString(contentNode, Program.DOMAIN);
+        String domainCode = _enumerationHelper.getItemCode(OdfEnumerationConstant.DOMAIN, domain);
+        
+        setProgramCatalog(mentionProgram);
+        mentionProgram.synchronizeMetadata(Program.DEGREE, true);
+        mentionProgram.setRemoteMetadata(Program.DEGREE, degreeCode);
+        
+        mentionProgram.synchronizeMetadata(Program.MENTION, true);
+        mentionProgram.setRemoteMetadata(Program.MENTION, mentionCode);
+        
+        mentionProgram.synchronizeMetadata(Program.DOMAIN, true);
+        mentionProgram.setRemoteMetadata(Program.DOMAIN, domainCode);
+    }
+    
+    /**
+     * Synchronized specific metadata to mention program
+     * @param mentionProgram the mention program
+     * @param doc the document
+     * @param contentNode the content node
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     */
+    protected void setMentionAdditionalMetadata(SynchronizableContent mentionProgram, Document doc, Node contentNode, String lang, SynchronizationReport report, Logger logger)
+    {
+        for (String metadataPath : _mentionMetadataPaths)
+        {
+            ContentType cType = _cTypeEP.getExtension(ProgramFactory.PROGRAM_CONTENT_TYPE);
+            if (ContentTypeHelper.getMetadataDefinitionByPath(cType, metadataPath) == null)
+            {
+                String warn = "Le chemin de la metadata " + metadataPath + " du programme n'est pas définie.";
+                report.warn(warn);
+                logger.warn(warn);
+            }
+            else
+            {
+                Node metadataNode = _xPathProcessor.selectSingleNode(contentNode, metadataPath);
+                try
+                {
+                    synchronizeMetadata(contentNode, doc, mentionProgram, metadataNode, report, logger, true, lang, null);
+                }
+                catch (WorkflowException e)
+                {
+                    String error = "Une erreur est survenue durant la synchronization de la metadata : " + metadataPath;
+                    logger.error(error);
+                    report.error(error);
+                }
+            }
+        }
+    }
+}
